org.apache.commons.math3.optim

## Class SimpleVectorValueChecker

- java.lang.Object
- - org.apache.commons.math3.optim.AbstractConvergenceChecker<PointVectorValuePair>
  - - org.apache.commons.math3.optim.SimpleVectorValueChecker

All Implemented Interfaces:
  ConvergenceChecker<PointVectorValuePair>

    public class SimpleVectorValueChecker
    extends AbstractConvergenceChecker<PointVectorValuePair>

Simple implementation of the `ConvergenceChecker` interface using only objective function values. Convergence is considered to have been reached if either the relative difference between the objective function values is smaller than a threshold or if either the absolute difference between the objective function values is smaller than another threshold for all vectors elements.
The `converged` method will also return `true` if the number of iterations has been set (see `this constructor`).

Since:
  3.0
Version:
  $Id: SimpleVectorValueChecker.java 1416643 2012-12-03 19:37:14Z tn $

### Field Summary

Fields
`private static int` `ITERATION_CHECK_DISABLED` If `maxIterationCount` is set to this value, the number of iterations will never cause `converged(int,PointVectorValuePair,PointVectorValuePair)` to return `true`.
`private int` `maxIterationCount` Number of iterations after which the `converged(int,PointVectorValuePair,PointVectorValuePair)` method will return true (unless the check is disabled).

### Constructor Summary

Constructors
Constructor and Description
`SimpleVectorValueChecker(double relativeThreshold, double absoluteThreshold)` Build an instance with specified thresholds.
`SimpleVectorValueChecker(double relativeThreshold, double absoluteThreshold, int maxIter)` Builds an instance with specified tolerance thresholds and iteration count.

### Method Summary

Methods
`boolean` `converged(int iteration, PointVectorValuePair previous, PointVectorValuePair current)` Check if the optimization algorithm has converged considering the last two points.

### Methods inherited from class org.apache.commons.math3.optim.AbstractConvergenceChecker

`getAbsoluteThreshold, getRelativeThreshold`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### ITERATION_CHECK_DISABLED

    private static final int ITERATION_CHECK_DISABLED

If `maxIterationCount` is set to this value, the number of iterations will never cause `converged(int,PointVectorValuePair,PointVectorValuePair)` to return `true`.

See Also:
  Constant Field Values

#### maxIterationCount

    private final int maxIterationCount

Number of iterations after which the `converged(int,PointVectorValuePair,PointVectorValuePair)` method will return true (unless the check is disabled).

### Constructor Detail

#### SimpleVectorValueChecker

    public SimpleVectorValueChecker(double relativeThreshold,
                            double absoluteThreshold)

Build an instance with specified thresholds. In order to perform only relative checks, the absolute tolerance must be set to a negative value. In order to perform only absolute checks, the relative tolerance must be set to a negative value.

Parameters:
  `relativeThreshold` - relative tolerance threshold
  `absoluteThreshold` - absolute tolerance threshold

#### SimpleVectorValueChecker

    public SimpleVectorValueChecker(double relativeThreshold,
                            double absoluteThreshold,
                            int maxIter)

Builds an instance with specified tolerance thresholds and iteration count. In order to perform only relative checks, the absolute tolerance must be set to a negative value. In order to perform only absolute checks, the relative tolerance must be set to a negative value.

Parameters:
  `relativeThreshold` - Relative tolerance threshold.
  `absoluteThreshold` - Absolute tolerance threshold.
  `maxIter` - Maximum iteration count.
Throws:
  `NotStrictlyPositiveException` - if `maxIter <= 0`.
Since:
  3.1

### Method Detail

#### converged

    public boolean converged(int iteration,
                    PointVectorValuePair previous,
                    PointVectorValuePair current)

Check if the optimization algorithm has converged considering the last two points. This method may be called several times from the same algorithm iteration with different points. This can be detected by checking the iteration number at each call if needed. Each time this method is called, the previous and current point correspond to points with the same role at each iteration, so they can be compared. As an example, simplex-based algorithms call this method for all points of the simplex, not only for the best or worst ones.

Specified by:
  `converged` in interface `ConvergenceChecker<PointVectorValuePair>`
Specified by:
  `converged` in class `AbstractConvergenceChecker<PointVectorValuePair>`
Parameters:
  `iteration` - Index of current iteration
  `previous` - Best point in the previous iteration.
  `current` - Best point in the current iteration.
Returns:
  `true` if the arguments satify the convergence criterion.